//+------------------------------------------------------------------
//|                                                      LabTrend.mq4 
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  DeepPink
#property indicator_color3  LimeGreen
#property indicator_color4  DeepPink
#property indicator_color5  LimeGreen
#property indicator_color6  DeepPink
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame       = "current time frame";
extern double Risk            = 3;
extern bool   ShowCandles     = true;
extern bool   ShowSignals     = true;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double wicUp[];
double wicDn[];
double barUp[];
double barDn[];
double arrUp[];
double arrDn[];
double trend[];
double trens[];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);  
      SetIndexBuffer(0, wicUp); 
      SetIndexBuffer(1, wicDn); 
      SetIndexBuffer(2, barUp); 
      SetIndexBuffer(3, barDn); 
      SetIndexBuffer(4, arrUp); SetIndexArrow(4,108);
      SetIndexBuffer(5, arrDn); SetIndexArrow(5,108);
      SetIndexBuffer(6, trend); 
      SetIndexBuffer(7, trens); 
   
      //
      //
      //
      //
      //
      
      if (ShowCandles)
            { SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexStyle(3,DRAW_HISTOGRAM); }
      else  { SetIndexStyle(0,DRAW_NONE);      SetIndexStyle(1,DRAW_NONE);      SetIndexStyle(2,DRAW_NONE);      SetIndexStyle(3,DRAW_NONE);  }
      if (ShowSignals)
            { SetIndexStyle(4,DRAW_ARROW); SetIndexStyle(5,DRAW_ARROW); }
      else  { SetIndexStyle(4,DRAW_NONE);  SetIndexStyle(5,DRAW_NONE);  }

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted(),length = 3+2*Risk;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);
       if (returnBars) { wicUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for (i = limit; i >= 0 ; i--)
      {
         
          double smin  =  Low[iLowest(NULL,0, MODE_LOW, length,i)];         
          double smax  = High[iHighest(NULL,0,MODE_HIGH,length,i)];  
          double bsmax = smax-(smax-smin)*(33.0-Risk)/100.0;	
          double bsmin = smin+(smax-smin)*(33.0-Risk)/100.0;
          trend[i] = trend[i+1];
          trens[i] = trens[i+1];

               if (Close[i] > bsmax) { trend[i] =  1; trens[i] =  1; }
               if (Close[i] < bsmin) { trend[i] = -1; trens[i] = -1; } 
                                    
         //
         //
         //
         //
         //
   
            wicUp[i] = EMPTY_VALUE;
            wicDn[i] = EMPTY_VALUE;
            barUp[i] = EMPTY_VALUE;
            barDn[i] = EMPTY_VALUE;
            arrUp[i] = EMPTY_VALUE;
            arrDn[i] = EMPTY_VALUE;

            if (trend[i] ==  1) 
            { 
              wicUp[i] = High[i]; wicDn[i] = Low[i]; 
              barUp[i] = MathMax(Open[i],Close[i]);
              barDn[i] = MathMin(Open[i],Close[i]); 
            }
            if (trend[i] == -1) 
            {
              wicUp[i] = Low[i];  wicDn[i] = High[i]; 
              barUp[i] = MathMin(Open[i],Close[i]);
              barDn[i] = MathMax(Open[i],Close[i]);
            }
            if (trens[i] != trens[i+1])
            {
              if (trens[i] ==  1) arrUp[i] = Low[i] -0.5*iATR(NULL,0,10,i);
              if (trens[i] == -1) arrDn[i] = High[i]+0.5*iATR(NULL,0,10,i);
            }
      }
      manageAlerts();
      return(0);
   }      

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         wicUp[i] = EMPTY_VALUE;
         wicDn[i] = EMPTY_VALUE;
         barUp[i] = EMPTY_VALUE;
         barDn[i] = EMPTY_VALUE;
         arrUp[i] = EMPTY_VALUE;
         arrDn[i] = EMPTY_VALUE;
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Risk,6,y);
         trens[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Risk,7,y);

         //
         //
         //
         //
         //
            
         if (trend[i] ==  1) 
         { 
           wicUp[i] = High[i]; wicDn[i] = Low[i]; 
           barUp[i] = MathMax(Open[i],Close[i]);
           barDn[i] = MathMin(Open[i],Close[i]); 
         }
         if (trend[i] == -1) 
         {
           wicUp[i] = Low[i];  wicDn[i] = High[i]; 
           barUp[i] = MathMin(Open[i],Close[i]);
           barDn[i] = MathMax(Open[i],Close[i]);
         }
         if (trens[i] != trens[i+1])
         {
           if (trens[i] ==  1) arrUp[i] = Low[i] -0.5*iATR(NULL,0,10,i);
           if (trens[i] == -1) arrDn[i] = High[i]+0.5*iATR(NULL,0,10,i);
         }
   }
manageAlerts();
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trens[whichBar] != trens[whichBar+1])
      {
         if (trens[whichBar] ==  1) doAlert(whichBar,"up");
         if (trens[whichBar] == -1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," LabTrend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"LabTrend"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}